#include <Servo.h>

Servo horizontal; // horizontal servo
int servoh = 180;
int servohLimitHigh = 175;
int servohLimitLow = 5;

Servo vertical; // vertical servo
int servov = 0;
int servovLimitHigh = 60;
int servovLimitLow = 0;

// LDR pin connections
// name = analogpin;
int ldrlt = A3;
int ldrrt = A0;
int ldrld = A2;
int ldrrd = A1;

const int button1 = 7;
const int button2 = 6;
const int motorA = D8;
const int motorB = D7;
int buttonStateA;
int buttonStateB;

int pos = 0;
int pos2 = 0;
int oldvalue;
int oldvalue2;

void setup() {
  horizontal.attach(3);
  vertical.attach(4);
  horizontal.write(180);
  vertical.write(0);
  pinMode(motorA, OUTPUT);
  pinMode(motorB, OUTPUT);
  pinMode(button1, INPUT);
  pinMode(button2, INPUT);
  delay(2500);
}

void loop() {
  int ldrStatus = analogRead(ldrlt);
  if (ldrStatus > 30) {
    buttonStateA = digitalRead(button1);
    if (buttonStateA == LOW) {
      digitalWrite(motorA, 255); // Counter-clockwise
      digitalWrite(motorB, LOW);
    } else {
      digitalWrite(motorA, LOW);
      digitalWrite(motorB, LOW);
    }

    int lt = analogRead(ldrlt);
    int rt = analogRead(ldrrt);
    int ld = analogRead(ldrld);
    int rd = analogRead(ldrrd);
    int dtime = 10;
    int tol = 90; // dtime = difference time, tol = tolerance
    int avt = (lt + rt) / 2; // average value top
    int avd = (ld + rd) / 2; // average value down
    int avl = (lt + ld) / 2; // average value left
    int avr = (rt + rd) / 2; // average value right
    int dvert = avt - avd; // check the difference of up and down
    int dhoriz = avl - avr; // check the difference of left and right

    if (-tol > dvert || dvert > tol) {
      if (avt > avd) {
        servov++;
        if (servov > servovLimitHigh) {
          servov = servovLimitHigh;
        }
      } else if (avt < avd) {
        servov--;
        if (servov < servovLimitLow) {
          servov = servovLimitLow;
        }
      }
      vertical.write(servov);
    }

    if (-tol > dhoriz || dhoriz > tol) {
      if (avl > avr) {
        servoh--;
        if (servoh < servohLimitLow) {
          servoh = servohLimitLow;
        }
      } else if (avl < avr) {
        servoh++;
        if (servoh > servohLimitHigh) {
          servoh = servohLimitHigh;
        }
      } else if (avl == avr) {
        delay(10);
      }
      horizontal.write(servoh);
    }
    delay(dtime);
  } else {
    oldvalue = horizontal.read();
    oldvalue2 = vertical.read();
    for (pos = oldvalue; pos <= 180; pos += 1) {
      horizontal.write(pos);
      delay(15);
    }
    for (pos2 = oldvalue2; pos2 <= 0; pos2 += 1) {
      vertical.write(pos2);
      delay(15);
    }
    buttonStateB = digitalRead(button2);
    if (buttonStateB == LOW) {
      digitalWrite(motorA, LOW); // Clockwise
      digitalWrite(motorB, 255);
    } else {
      digitalWrite(motorA, LOW);
      digitalWrite(motorB, LOW);
    }
  }
}